<?php
if (!defined('IN_CONTEXT')) die('access violation error!');

class ModProduct extends Module {

	protected $_filters = array(
        'check_admin' => ''
    );
	
    public function admin_list() {
        $this->_layout = 'content';

        $curr_locale = trim(SessionHolder::get('_LOCALE'));
        $mod_locale = trim(SessionHolder::get('mod_product/_LOCALE', $curr_locale));
        $lang_sw = trim(ParamHolder::get('lang_sw', $mod_locale));
        SessionHolder::set('mod_product/_LOCALE', $lang_sw);

        $where = "s_locale=?";
        $params = array($lang_sw);

        $cap_sw = trim(ParamHolder::get('cap_sw', '-'));
        if (is_numeric($cap_sw)) {
            $where .= " AND product_category_id =?";
            $params[] = $cap_sw;
        }

        $product_data =&
            Pager::pageByObject('Product', $where, $params,
                "ORDER BY `id` DESC");
        $this->assign('next_action', 'admin_order');
        $this->assign('products', $product_data['data']);
        $this->assign('pager', $product_data['pager']);
        $this->assign('cap_sw', $cap_sw);
        $this->assign('lang_sw', $lang_sw);
        $this->assign('langs', Toolkit::loadAllLangs());
        $this->assign('roles', Toolkit::loadAllRoles());

		// Prepare Product category for select list view
        $all_categories =& ProductCategory::listCategories(0, "s_locale=?", array($lang_sw));
        $select_categories = array();
        ProductCategory::toSelectArray($all_categories, $select_categories,
                0, array(), array('-' => __('View All'), '0' => __('Uncategorised')));

        $this->assign('select_categories', $select_categories);
    }
	public function admin_order() {

		$order_info =& ParamHolder::get('i_order', array());
		if (!is_array($order_info)) {
            $this->assign('json', Toolkit::jsonERR(__('Missing product order information!')));
            return '_result';
        }
		try {
			foreach($order_info as $key => $val) {
				$product_info['i_order'] = $val;
				$o_product = new Product($key);
				$o_product->set($product_info);
				$o_product->save();
			}
		} catch (Exception $ex) {
			$this->assign('json', Toolkit::jsonERR($ex->getMessage()));
			return '_result';
		}
		Notice::set('mod_product/msg', __('Product order added successfully!'));
		Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_list'));
	}
    public function admin_add() {
        $this->_layout = 'content';

        $curr_locale = trim(SessionHolder::get('_LOCALE'));
        $mod_locale = trim(SessionHolder::get('mod_product/_LOCALE', $curr_locale));

        $all_categories =& ProductCategory::listCategories(0, "s_locale=?", array($mod_locale));
        $select_categories = array();
        ProductCategory::toSelectArray($all_categories, $select_categories,
	        	0, array(), array('0' => __('Uncategorised')));

        $this->assign('content_title', __('New Product'));
        $this->assign('next_action', 'admin_create');

        $this->assign('mod_locale', $mod_locale);
        $this->assign('select_categories', $select_categories);
        $this->assign('langs', Toolkit::loadAllLangs());
        $this->assign('roles', Toolkit::loadAllRoles());
		$this->assign('act', 'add');
        return '_form';
    }
    
    public function admin_mi_quick_add() {
        $curr_locale = trim(SessionHolder::get('_LOCALE'));
        $mod_locale = trim(SessionHolder::get('mod_menu_item/_LOCALE', $curr_locale));

        $all_categories =& ProductCategory::listCategories(0, "s_locale=?", array($mod_locale));
        $select_categories = array();
        ProductCategory::toSelectArray($all_categories, $select_categories,
	        	0, array(), array('0' => __('Uncategorised')));

        $this->assign('content_title', __('New Product'));
        $this->assign('next_action', 'admin_mi_quick_create');

        $this->assign('mod_locale', $mod_locale);
        $this->assign('select_categories', $select_categories);
        $this->assign('langs', Toolkit::loadAllLangs());
        $this->assign('roles', Toolkit::loadAllRoles());
        
        $link_type_text = trim(ParamHolder::get('txt'));
        $this->assign('type_text', $link_type_text);

        $this->_layout = 'clean';
        return '_mi_quick_add_form';
    }

    public function admin_create() {
		$this->_layout = 'content';

        $product_info =& ParamHolder::get('prd', array());
        if (sizeof($product_info) <= 0) {
            $this->assign('json', Toolkit::jsonERR(__('Missing product information!')));
            return '_error';
        }
    	if($product_info['product_category_id'] == -1) {
        	$product_info['product_category_id'] == 0;
        }
		$file_info =& ParamHolder::get('prd_file', array(), PS_FILES);
		if (empty($file_info)) {
            Notice::set('mod_product/msg', __('Invalid post file data!'));
            Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_add'));
        }
		if(!preg_match('/\.('.PIC_ALLOW_EXT.')$/i', $file_info["name"])) {
			Notice::set('mod_product/msg', __('Big image type error!'));
            Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_add'));
		}
		
        if(file_exists(ROOT.'/upload/image/'.$file_info["name"])) {
            $file_info["name"] = Toolkit::randomStr(8).strrchr($file_info["name"],".");
        }
        if (!$this->_savelinkimg($file_info)) {
            Notice::set('mod_product/msg', __('Product big image upload failed!'));
            Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_add'));
        } else {
        	
        	// 水印图片
		    $markpic = $this->waterMark( $file_info["name"], 'index.php?'.Html::uriquery('mod_product', 'admin_add') );
		    // 缩略图
		    $file_small_info["name"] = $this->smallImg( $file_info["name"] );
		    $file_info["name"] = $markpic;
        }

		/*$file_small_info =& ParamHolder::get('prd_small_file', array(), PS_FILES);
		if (empty($file_small_info)) {
            Notice::set('mod_product/msg', __('Invalid post file data!'));
            Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_add'));
        }
		if(!preg_match('/\.('.PIC_ALLOW_EXT.')$/i', $file_small_info["name"])) {
			Notice::set('mod_product/msg', __('Small image type not allowed!'));
            Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_add'));
		}
        if(file_exists(ROOT.'/upload/image/'.$file_small_info["name"])) {
            $file_small_info["name"] = Toolkit::randomStr(8).strrchr($file_small_info["name"],".");
        }
        if (!$this->_savelinkimg($file_small_info)) {
            Notice::set('mod_product/msg', __('Product small image upload failed!'));
            Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_add'));
        }*/

		$is_member_only = ParamHolder::get('ismemonly', '0');
        try {
			 $product_info['feature_img'] = "upload/image/".$file_info["name"];
			 $product_info['feature_smallimg'] = "upload/image/".$file_small_info["name"];
        	// Re-arrange publish time
        	//if (intval(ParamHolder::get('pub_start_time', '0')) == 0) {
        	    $product_info['pub_start_time'] = -1;
        	//} else {
        	//    $product_info['pub_start_time'] = strtotime($product_info['pub_start_time']);
        	//}
        	//if (intval(ParamHolder::get('pub_end_time', '0')) == 0) {
        	    $product_info['pub_end_time'] = -1;
        	//} else {
        	//    $product_info['pub_end_time'] = strtotime($product_info['pub_end_time']);
        	//}
        	// Re-arrange recommend status
            if ($product_info['recommended'] == '1') {
                $product_info['recommended'] = '1';
            } else {
                $product_info['recommended'] = '0';
            }
        	// Re-arrange publish status
//            if ($product_info['published'] == '1') {
//                $product_info['published'] = '1';
//            } else {
//                $product_info['published'] = '0';
//            }
				$product_info['published'] = '1';
        	// Re-arrange online orderable status
            if ($product_info['online_orderable'] == '1') {
                $product_info['online_orderable'] = '1';
            } else {
                $product_info['online_orderable'] = '0';
            }

			// Re-arrange prices for basic version
			if (!isset($product_info['price'])) {
				$product_info['price'] = '0.00';
			}
			if (!isset($product_info['discount_price'])) {
				$product_info['discount_price'] = '0.00';
			}
			if (!isset($product_info['delivery_fee'])) {
				$product_info['delivery_fee'] = '0.00';
			}
			
            // Re-arrange discount price
            if (number_format($product_info['discount_price'], 2) == '0.00') {
                $product_info['discount_price'] = $product_info['price'];
            }
            $product_info['for_roles'] = ACL::explainAccess(intval($is_member_only));
            // The create time
            $product_info['create_time'] = time();
            $product_info['i_order'] =
            	Product::getMaxOrder($product_info['product_category_id']) + 1;
            // Data operation
            $o_product = new Product();
            $o_product->set($product_info);
            $o_product->save();
            
            $this->_upload_gala_pics($o_product->id, ParamHolder::get('prd_extpic', array(), PS_FILES));
        } catch (Exception $ex) {
            $this->assign('json', Toolkit::jsonERR($ex->getMessage()));
            return '_error';
        }

       Notice::set('mod_product/msg', __('Product added successfully!'));
       Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_list'));
    }
    
    public function admin_mi_quick_create() {
		$this->_layout = 'clean';

        $product_info =& ParamHolder::get('prd', array());
        if (sizeof($product_info) <= 0) {
            $this->assign('json', Toolkit::jsonERR(__('Missing product information!')));
            return '_error';
        }
		$file_info =& ParamHolder::get('prd_file', array(), PS_FILES);
		if (empty($file_info)) {
            Notice::set('mod_product/msg', __('Invalid post file data!'));
            Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_mi_quick_add'));
        }
		if(!preg_match('/\.('.PIC_ALLOW_EXT.')$/i', $file_info["name"])) {
			Notice::set('mod_product/msg', __('Big image type error!'));
            Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_mi_quick_add'));
		}
        if(file_exists(ROOT.'/upload/image/'.$file_info["name"])) {
            $file_info["name"] = Toolkit::randomStr(8).strrchr($file_info["name"],".");
        }
        if (!$this->_savelinkimg($file_info)) {
            Notice::set('mod_product/msg', __('Product big image upload failed!'));
            Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_mi_quick_add'));
        } else {
        	// 水印图片
		    $markpic = $this->waterMark( $file_info["name"], 'index.php?'.Html::uriquery('mod_product', 'admin_mi_quick_add') );
		    // 缩略图
		    $file_small_info["name"] = $this->smallImg( $file_info["name"] );
		    $file_info["name"] = $markpic;
        }

		/*$file_small_info =& ParamHolder::get('prd_small_file', array(), PS_FILES);
		if (empty($file_small_info)) {
            Notice::set('mod_product/msg', __('Invalid post file data!'));
            Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_mi_quick_add'));
        }
		if(!preg_match('/\.('.PIC_ALLOW_EXT.')$/i', $file_small_info["name"])) {
			Notice::set('mod_product/msg', __('Small image type not allowed!'));
            Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_mi_quick_add'));
		}
        if(file_exists(ROOT.'/upload/image/'.$file_small_info["name"])) {
            $file_small_info["name"] = Toolkit::randomStr(8).strrchr($file_small_info["name"],".");
        }
        if (!$this->_savelinkimg($file_small_info)) {
            Notice::set('mod_product/msg', __('Product small image upload failed!'));
            Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_mi_quick_add'));
        }*/

		$is_member_only = ParamHolder::get('ismemonly', '0');
        try {
			 $product_info['feature_img'] = "upload/image/".$file_info["name"];
			 $product_info['feature_smallimg'] = "upload/image/".$file_small_info["name"];
        	// Re-arrange publish time
        	//if (intval(ParamHolder::get('pub_start_time', '0')) == 0) {
        	    $product_info['pub_start_time'] = -1;
        	//} else {
        	//    $product_info['pub_start_time'] = strtotime($product_info['pub_start_time']);
        	//}
        	//if (intval(ParamHolder::get('pub_end_time', '0')) == 0) {
        	    $product_info['pub_end_time'] = -1;
        	//} else {
        	//    $product_info['pub_end_time'] = strtotime($product_info['pub_end_time']);
        	//}
        	// Re-arrange recommend status
            if ($product_info['recommended'] == '1') {
                $product_info['recommended'] = '1';
            } else {
                $product_info['recommended'] = '0';
            }
        	// Re-arrange publish status
//            if ($product_info['published'] == '1') {
//                $product_info['published'] = '1';
//            } else {
//                $product_info['published'] = '0';
//            }
				$product_info['published'] = '1';
        	// Re-arrange online orderable status
            if ($product_info['online_orderable'] == '1') {
                $product_info['online_orderable'] = '1';
            } else {
                $product_info['online_orderable'] = '0';
            }

			// Re-arrange prices for basic version
			if (!isset($product_info['price'])) {
				$product_info['price'] = '0.00';
			}
			if (!isset($product_info['discount_price'])) {
				$product_info['discount_price'] = '0.00';
			}
			if (!isset($product_info['delivery_fee'])) {
				$product_info['delivery_fee'] = '0.00';
			}
			
            // Re-arrange discount price
            if (number_format($product_info['discount_price'], 2) == '0.00') {
                $product_info['discount_price'] = $product_info['price'];
            }
            $product_info['for_roles'] = ACL::explainAccess(intval($is_member_only));
            // The create time
            $product_info['create_time'] = time();
            $product_info['i_order'] =
            	Product::getMaxOrder($product_info['product_category_id']) + 1;
            // Data operation
            $o_product = new Product();
            $o_product->set($product_info);
            $o_product->save();
            
            $this->_upload_gala_pics($o_product->id, ParamHolder::get('prd_extpic', array(), PS_FILES));
        } catch (Exception $ex) {
            $this->assign('json', Toolkit::jsonERR($ex->getMessage()));
            return '_error';
        }

        $link_type_text = trim(ParamHolder::get('txt'));
        $this->assign('type_text', $link_type_text);
        $this->assign('id', $o_product->id);
        $this->assign('name', $o_product->name);
        return '_mi_quick_add_success';
    }

    public function admin_edit() {
        $this->_layout = 'content';

        $p_id = ParamHolder::get('p_id', '0');
        if (intval($p_id) == 0) {
            $this->assign('json', Toolkit::jsonERR(__('Invalid ID!')));
            return '_error';
        }

        try {
            $curr_product = new Product($p_id);
            $this->assign('curr_product', $curr_product);

	        $all_categories =& ProductCategory::listCategories(0, "s_locale=?", array($curr_product->s_locale));
	        $select_categories = array();
	        ProductCategory::toSelectArray($all_categories, $select_categories,
		        	0, array(), array('0' => __('Uncategorised')));
	        $this->assign('select_categories', $select_categories);
        } catch (Exception $ex) {
            $this->assign('json', Toolkit::jsonERR($ex->getMessage()));
            return '_error';
        }

        $this->assign('content_title', __('Edit Product'));
        $this->assign('next_action', 'admin_update');
        $this->assign('p_id', $p_id);

        $this->assign('langs', Toolkit::loadAllLangs());
        $this->assign('roles', Toolkit::loadAllRoles());

        return '_form';
    }

    public function admin_update() {
        $product_info =& ParamHolder::get('prd', array());
        if (sizeof($product_info) <= 0) {
            $this->assign('json', Toolkit::jsonERR(__('Missing product information!')));
            return '_error';
        }
		$file_info =& ParamHolder::get('prd_file', array(), PS_FILES);
		if (!empty($file_info["name"])) {
			if(!preg_match('/\.('.PIC_ALLOW_EXT.')$/i', $file_info["name"])) {
				Notice::set('mod_product/msg', __('Big image type error!'));
				Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_edit', array('p_id' => $product_info['id'])));
			}
			if(file_exists(ROOT.'/upload/image/'.$file_info["name"])) {
				$file_info["name"] = Toolkit::randomStr(8).strrchr($file_info["name"],".");
			}
			if (!$this->_savelinkimg($file_info)) {
				Notice::set('mod_product/msg', __('Product big image upload failed!'));
				Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_edit', array('p_id' => $product_info['id'])));
			} else {
	        	// 水印图片
			    $markpic = $this->waterMark( $file_info["name"], 'index.php?'.Html::uriquery('mod_product', 'admin_edit', array('p_id' => $product_info['id'])) );
			    // 缩略图
			    $file_small_info["name"] = $this->smallImg( $file_info["name"] );
			    $file_info["name"] = $markpic;
	        }
		}
		/*$file_small_info =& ParamHolder::get('prd_small_file', array(), PS_FILES);
		if (!empty($file_small_info["name"])) {
			if(!preg_match('/\.('.PIC_ALLOW_EXT.')$/i', $file_small_info["name"])) {
				Notice::set('mod_product/msg', __('Small image type error!'));
				Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_edit', array('p_id' => $product_info['id'])));
			}
			if(file_exists(ROOT.'/upload/image/'.$file_small_info["name"])) {
				$file_small_info["name"] = Toolkit::randomStr(8).strrchr($file_small_info["name"],".");
			}
			if (!$this->_savelinkimg($file_small_info)) {
				Notice::set('mod_product/msg', __('Product small image upload failed!'));
				Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_edit', array('p_id' => $product_info['id'])));
			}
		}*/

        $is_member_only = ParamHolder::get('ismemonly', '0');
        try {
			//add image
			if (!empty($file_info["name"])) {
				$product_info['feature_img'] = "upload/image/".$file_info["name"];
			}
			if (!empty($file_small_info["name"])) {
				$product_info['feature_smallimg'] = "upload/image/".$file_small_info["name"];
			}
        	// Re-arrange publish time
        	//if (intval(ParamHolder::get('pub_start_time', '0')) == 0) {
        	    $product_info['pub_start_time'] = -1;
        	//} else {
        	//    $product_info['pub_start_time'] = strtotime($product_info['pub_start_time']);
        	//}
        	//if (intval(ParamHolder::get('pub_end_time', '0')) == 0) {
        	    $product_info['pub_end_time'] = -1;
        	//} else {
        	//    $product_info['pub_end_time'] = strtotime($product_info['pub_end_time']);
        	//}
        	// Re-arrange recommend status
            if ($product_info['recommended'] == '1') {
                $product_info['recommended'] = '1';
            } else {
                $product_info['recommended'] = '0';
            }
        	// Re-arrange publish status
//            if ($product_info['published'] == '1') {
//                $product_info['published'] = '1';
//            } else {
//                $product_info['published'] = '0';
//            }
        	// Re-arrange online orderable status
            if ($product_info['online_orderable'] == '1') {
                $product_info['online_orderable'] = '1';
            } else {
                $product_info['online_orderable'] = '0';
            }
            // Re-arrange discount price
            if (number_format($product_info['discount_price'], 2) == '0.00') {
                $product_info['discount_price'] = number_format($product_info['price'],2);
            }
            $product_info['for_roles'] = ACL::explainAccess(intval($is_member_only));

            // Data operation
            $o_product = new Product($product_info['id']);
            $o_product->set($product_info);
            $o_product->save();
            
            $this->_upload_gala_pics($o_product->id, ParamHolder::get('prd_extpic', array(), PS_FILES));
        } catch (Exception $ex) {
            $this->assign('json', Toolkit::jsonERR($ex->getMessage()));
            return '_error';
        }

       Notice::set('mod_product/msg', __('Product updated successfully!'));
       Content::redirect('index.php?'.Html::uriquery('mod_product', 'admin_list'));
    }

    public function admin_delete() {

        $p_id = trim(ParamHolder::get('p_id', '0'));
        if (intval($p_id) == 0) {
            $this->assign('json', Toolkit::jsonERR(__('Invalid ID!')));
            return '_result';
        }
        try {
			$tmp_arr = explode('_', $p_id);
			$len = sizeof($tmp_arr);
			for ($i = 0; $i< $len; $i++){
				$curr_product = new Product($tmp_arr[$i]);
				$curr_product->delete();
			}
        } catch (Exception $ex) {
            $this->assign('json', Toolkit::jsonERR($ex->getMessage()));
            return ('_result');
        }

        $this->assign('json', Toolkit::jsonOK());
        return '_result';
    }
    
    public function admin_delete_extpic() {
        $p_id = trim(ParamHolder::get('p_id', '0'));
        if (intval($p_id) == 0) {
            $this->assign('json', Toolkit::jsonERR(__('Invalid ID!')));
            return '_result';
        }
        try {
				$curr_pic = new ProductPic($p_id);
				@unlink(ROOT.'/'.$curr_pic->pic);
				$curr_pic->delete();
        } catch (Exception $ex) {
            $this->assign('json', Toolkit::jsonERR($ex->getMessage()));
            return ('_result');
        }
        
        $this->assign('json', Toolkit::jsonOK(array('id' => $p_id)));
        return '_result';
    }

	private function _savelinkimg($struct_file) {
		$struct_file['name'] = iconv("UTF-8", "gb2312", $struct_file['name']);
        return move_uploaded_file($struct_file['tmp_name'], ROOT.'/upload/image/'.$struct_file['name']);
    }
    
    private function _upload_gala_pics($product_id, $html_file) {
        if (sizeof($html_file) == 0) return;
        for ($i = 0; $i < sizeof($html_file['name']); $i++) {
            if ($html_file['error'][$i] > 0) continue;
            $rand_fname = Toolkit::randomStr(8).'_'.$html_file['name'][$i];
            if (move_uploaded_file($html_file['tmp_name'][$i], 
                    ROOT.'/upload/image/'.$rand_fname)) {
                $ext_prd_pic = new ProductPic();
                $ext_prd_pic->product_id = $product_id;
                // 水印图片
                $rand_fname = $this->waterMark( $rand_fname, '', '' );
                $ext_prd_pic->pic = 'upload/image/'.$rand_fname;
                $ext_prd_pic->save();
            }
        }
    }
    
	public function admin_pic()
    {
    	$product_info = array();
    	$product_id = trim(ParamHolder::get('_id', ''));
    	if(!empty($product_id))
    	{
    		$o_product = new Product($product_id);
            if($o_product->published == 1)
            {
            	$product_info['published'] = '0';
            	$o_product->set($product_info);
            	$o_product->save();
				die('0');
            }
            elseif($o_product->published == 0)
            {
            	$product_info['published'] = '1';
            	$o_product->set($product_info);
            	$o_product->save();
				die('1');
            }
    	}
    }
    
    // 26/04/2010 Jane Add >>
    private function getInfo( $photo )
	{ 
	    $photo = ROOT.'/upload/image/'.$photo;
	    $image_info = getimagesize( "{$photo}" ); 
	    $imginfo["width"] = $image_info[0]; 
	    $imginfo["height"] = $image_info[1]; 
	    $imginfo["type"] = $image_info[2]; 
	    $imginfo["name"] = basename( $photo );
	    
	    return $imginfo; 
	} 

	public function smallImg( $photo, $width=180, $height=180 )  
	{ 
		$photo = mb_convert_encoding( $photo, 'gb2312', 'utf8' );	  
	    $imginfo = $this->getInfo( $photo );
	    // 获得图片源 
	    $photo = ROOT.'/upload/image/'.$photo;
	    // 新图片名称
        $newname = $imginfo["name"];
	    
	    if($imginfo["type"] == 1)  { 
	        $img = imagecreatefromgif( $photo ); 
	    } elseif( $imginfo["type"] == 2 ) {
	        $img = imagecreatefromjpeg( $photo ); 
	    } elseif( $imginfo["type"] == 3 ) { 
	        $img = imagecreatefrompng( $photo ); 
	    } else { 
	        $img = ""; 
	    }
	    
	    if( empty($img) ) return $newname; 
	    
	    $srcW = $imginfo["width"];   
	    $srcH = $imginfo["height"];  
	    $width = ($width > $srcW) ? $srcW : $width;   
	    $height = ($height > $srcH) ? $srcH : $height;   
	    if( $srcW * $width > $srcH * $height ) { 
	        $height = round( $srcH * $width / $srcW ); 
	    } else { 
	        $width = round( $srcW * $height / $srcH ); 
	    } 
	    if( function_exists("imagecreatetruecolor") ) { 
	        $newImg = imagecreatetruecolor( $width, $height ); 
	        ImageCopyResampled( $newImg, $img, 0, 0, 0, 0, $width, $height, $srcW, $srcH ); 
	    } else { 
	        $newImg = imagecreate( $width, $height ); 
	        ImageCopyResized( $newImg, $img, 0, 0, 0, 0, $width, $height, $srcW, $srcH ); 
	    } 

        if( file_exists( ROOT.'/upload/image/'.$newname ) ) @unlink( ROOT.'/upload/image/'.$newname ); 
        ImageJPEG( $newImg, ROOT.'/upload/image/'.$newname, 90 ); 

	    ImageDestroy( $newImg ); 
	    ImageDestroy( $img );
	    
	    return mb_convert_encoding( $newname, 'utf8', 'gb2312' );
	} 

	public function waterMark( $photo, $url, $prefix = 'mark_' )
	{ 
		$photo = mb_convert_encoding( $photo, 'gb2312', 'utf8' );
	    $imginfo = $this->getInfo( $photo ); 
	    $photo = ROOT.'/upload/image/'.$photo;
        $newname = $prefix.$imginfo["name"];
	    
	    switch ( $imginfo["type"] ) { 
	        case 1: 
	            $img = imagecreatefromgif( $photo ); 
	            break; 
	        case 2: 
	            $img = imagecreatefromjpeg( $photo ); 
	            break; 
	        case 3: 
	            $img = imagecreatefrompng( $photo ); 
	            break; 
	        default: 
	        	$img = "";
	            break;
	    } 
	    if( empty($img) ) return str_replace( 'mark_', '', $newname ); 

		$width = $imginfo["width"];
		$height = $imginfo["height"];

	    if( function_exists("imagecreatetruecolor") ) { 
	        $newImg = imagecreatetruecolor( $width, $height ); 
	        ImageCopyResampled( $newImg, $img, 0, 0, 0, 0, $width, $height, $width, $height ); 
	    } else {
	        $newImg = imagecreate( $width, $height ); 
	        ImageCopyResized( $newImg, $img, 0, 0, 0, 0, $width, $height, $width, $height ); 
	    } 
	    
	    // 是否水印
	    $ismarked = IS_MARKED;
	    $text = WATER_MARK;
	    if( $ismarked && isset($text) && !empty($text) ) {
	    	//$white = imageColorAllocate( $newImg, 255, 255, 255 ); 
		    $black = imageColorAllocate( $newImg, 149, 3, 19 ); 
		    $alpha = imageColorAllocateAlpha( $newImg, 149, 3, 19, 80 ); 
		    //ImageFilledRectangle( $newImg, 0, $height-26, $width, $height, $alpha ); 
		    //ImageFilledRectangle( $newImg, 13, $height-20, 15, $height-7, $black ); 
		   // ImageTTFText( $newImg, 10, 0, 20, $height-16, $black, ROOT.'/admin/logoEditor/font/windows/FangSong.ttf', $text[0] );
		    $temp = imagettfbbox( ceil(5*4.8), 0, ROOT.'/locale/FZYTK.TTF', $text );
		    $w = $temp[2] - $temp[6]; 
       	    $h = $temp[3] - $temp[7]; 
       	    $posX = ($width - $w) / 2; 
            $posY = ($height - $h) / 2;
            // range out
            if( ($posX < 0 || $posY < 0) && !empty($url) ) {
            	Notice::set('mod_product/msg', __('Watermark is out of range!'));
           		Content::redirect($url);
            } else {
            	ImageTTFText( $newImg, 24, 0, $posX, $posY, $alpha, ROOT.'/locale/FZYTK.TTF', $text );
            }
	    }

        if( file_exists( ROOT.'/upload/image/'.$newname ) ) @unlink( ROOT.'/upload/image/'.$newname ); 
        ImageJPEG( $newImg, ROOT.'/upload/image/'.$newname, 90 ); 
	    
	    ImageDestroy( $newImg ); 
	    ImageDestroy( $img ); 
	    return mb_convert_encoding( $newname, 'utf8', 'gb2312' );
	}
    // 26/04/2010 Jane Add <<
}
?>
